(*Ŀ
  Version                                                                 
                                                                 
                                                                            
 ??/??/2001 => Cration du projet 'Pong'                                    
 09/05/2001 => Version 0.7 : Haypo passe par l                             
   * Remise en forme du code = rorganisation en procdure/fonction, rgla- 
     ge de l'espacement, etc.                                               
   * Mise en couleur du jeu                                                 
   * Nom de variables beaucoup plus clairs                                  
   * Vrai intelligence artificielle pour le joueur CPU                      
   * Utilisation de constantes au lieu de nombres qui ne veulent rien dire  
   * Et encore un peu de rorganisation : gnralisation des procdures     
 20/05/2001 => Version 0.8                                                  
   + Utilisation d'un tampon pour l'affichage (vite le syntillement)       
     (a prend 64 Ko de mmoire et faut appeler 'AfficheEcran')             
   + IA  plusieurs niveau 1 (suit la balle), 2 (se centre quand c'est +   
     lui), GOD (se centre rapidement)                                       
   + Presque tout customisable :                                            
     1) Vitesse : joueur1, joueur2, la balle                                
     2) l'intelligence artificielle                                         
     3) Position du cadre (plafond et sol)                                  
     4) Position des textes                                                 
     5) Toutes les couleurs                                                 
   + Fondu  la sortie (fin du jeu)                                         
   + Affichage du texte style 'mode machine' (une lettre aprs l'autre)     
     pour la procdure de fin                                               
   ! Tests de la position de la balle corrigs                              
88*)
(*88ĳ
  A venir                                                                 
                                                                 
                                                                            
 -> Gestion de la manette                                                   
 -> Choix de la difficulte                                                 
 -> Mode Survie (nombre de vie choisi par le joueur, a conserver le plus    
 longtemp possible.                                                         
                                                                            
 -> Sauvegarde pour le mode survie                                          
 -> Cheat code ? (peut tre...)                                             
*)

{ ---- Directive de compilation pour Borland Turbo Pascal 7 ------- }
{$M 4096,0,64500} { 4 Ko de pile, 64 Ko de mmoire dynamique }
{ ------ Options de compilation Haypo ------ }
{$DEFINE BalleCarre: Dessine une balle carr}
{-$DEFINE Debug: Mode debug le jeu}
{                * Pas d'intro }
{                * Touche espace = pause }

Program PONG;

Uses
  EcranVGA, { Filet, balle raquette, EcriVga }
  clavier,  { touche tendue (haut, bas) litTouche, touchePresse; }
  sonHP,    { gestion du buzzeur grace a une procedure ASM (ultra rapide }
  FaitPaus, { pour bloquer le prog... pendant quelques millisecondes }
  EcranTxt, { gestion du mode text. }
  PCX,      { affiche des images au format pcx }
  palVideo; { gestion de la palette }

const
  Version = '0.8.5';

  { Dimensions }
  LargJoueur1 = 3; HautJoueur1 = 30;
  LargJoueur2 = 3; HautJoueur2 = 30;

  LargEcran = 320; HautEcran = 200;
  CadreHaut = 1;    { Y du cadre en haut }
  CadreBas = HautEcran-1-8*2;  { Y du cadre en bas }
  CadreCentre = CadreBas div 2 - HautJoueur1 div 2;

  LargBalle = 5; HautBalle = 5;
  RayonBalle = 3;

  LargGrosseBarre = LargEcran;
  HautGrosseBarre = 15;


  { Couleur }
  Noir = 0;
  BleuFonce = 1;
  Vert = 3;
  Gris = 7;
  Rose = 13;
  RougeC = 12; {RougeClair}
  RougeF = 4; {RougeFonc}
  Jaune = 14;
  Blanc = 15;

  CoulBalle = 253;
  CoulCadre = Blanc;
  CoulJoueur1 = 254;
  CoulJoueur2 = 254;
  CoulFond = BleuFonce;

  { Score }

  ScoreMin = -20;     { Score en de duquel on est considr comme 'nul' }
  LongScoreMax = 3;   { Longueur (en caractre) max du score (n'oubliez pas }
                      { le '-') }
  ScoreMax = 30;      { Score  atteindre pour gagner }


  CoulTxtScore = 255;
  CoulTxtScoreFond = 245;

  TxtX_Score1 = 0;
  TxtScoreY = HautEcran-8*2;
  TxtX_Score2 = 296;

  { Vitesse }
  TxtVitesseX = 0;
  TxtVitesseY = HautEcran-8*1;
  VitesseMin = 0.1;
  VitesseMax = 3;
  CoulTxtVitesse = 255;
  CoulTxtVitesseFond = 50;


var
  NiveauIA: Byte;
  balle: record
    Xr,Yr: Real;
    PlusX,PlusY: Real;
    X,Y: integer;
    SauveFond: Array[0..LargBalle*HautBalle-1] of byte;
  end;
  Joueur1: Record
    X,Y: integer;
    Vitesse: Byte;
    SauveFond: Array[0..LargJoueur1*HautJoueur1-1] of byte;
  end;
  Joueur2: Record
    X,Y: integer;
    Vitesse: Byte;
    SauveFond: Array[0..LargJoueur2*HautJoueur2-1] of byte;
  end;

  txt: string;
  Vitesse: Real;

  key : char;
  iy: Word;
  SCORE1,SCORE2 : integer;

{/////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////}

Procedure AfficheChoix;
Begin;
  DessineRectangle(13,50,87,44,15);
  DessineRectangle(14,51,85,42,15);
  DessineRectanglePlein(15,52,83,40,CouleurNoire);
End;


Procedure AfficheAide(quoi: shortint);
Begin;
  DessineRectangle(150,50,170,150,249);
  DessineRectangle(151,51,168,148,249);
  DessineRectanglePlein(152,52,166,146,CouleurNoire);
  DessineLigneH(152,70,166,14);
  ecriVGA(164,57,'HELP - HELP - HELP',254,CouleurNoire);
  IF quoi=1 then BEGIN;
    { affiche l'aide pour le mode de jeux 1 (mode 1) }
    EcriVGA(154,72,'Vous jouez contre le PC. le premier a atteindre 30 points a gagner.',CouleurBlanche,CouleurNoire);
  End
    ELSE
  Begin
    EcriVGA(154,72,'Information divers',CouleurBlanche,CouleurNoire);
  end;
End;


procedure EmetSon (Frequence,Duree: Word); begin
  Son (Frequence);
  Pause (Duree);
  CoupeSon;
end;

procedure EffaceJoueur (index: byte); begin
  if index=1 then
    EcritZone (joueur1.X,Joueur1.Y,LargJoueur1,HautJoueur1,Joueur1.SauveFond)
  else
    EcritZone (joueur2.X,Joueur2.Y,LargJoueur2,HautJoueur2,Joueur2.SauveFond)
end;

procedure DessineJoueur (index: byte); begin
  if index=1 then
    begin
      LitZone (joueur1.X,Joueur1.Y,LargJoueur1,HautJoueur1,Joueur1.SauveFond);
      DessineRectanglePlein (joueur1.X,joueur1.Y,Largjoueur1,Hautjoueur1,CoulJoueur1);
    end
  else
    begin
      LitZone (joueur2.X,Joueur2.Y,LargJoueur2,HautJoueur2,Joueur2.SauveFond);
      DessineRectanglePlein (joueur2.X,joueur2.Y,Largjoueur2,Hautjoueur2,CoulJoueur2);
    end;
end;

procedure InitBalle (plus: shortint); begin with Balle do begin
  Randomize;
  Xr := LargEcran div 2;  X := Round(Xr);
  Yr := CadreCentre;      Y := Round(Yr);
  PlusX := Vitesse*plus;
  if Random(2)=1 then PlusY := -Vitesse else PlusY := Vitesse;
end end;

procedure EffaceBalle; begin
  { Remet le fond de la balle }
  EcritZone (Balle.X,Balle.Y,LargBalle,HautBalle,Balle.SauveFond);
end;

procedure DessineBalle; begin
  { Sauve le fond de la balle }
  LitZone (Balle.X,Balle.Y,LargBalle,HautBalle,Balle.SauveFond);

  { Dessine la balle }
  {$IFDEF BalleCarre}
    { Balle carre }
    DessineRectanglePlein (Balle.X,Balle.Y,LargBalle,HautBalle,CoulBalle);
  {$ELSE}
{$IFDEF Debug}
DessineRectanglePlein (Balle.X,Balle.Y,LargBalle,HautBalle,CoulFond+1);
{$ENDIF}
    { Balle ronde }
    DessineDisque (Balle.X+RayonBalle,Balle.Y+RayonBalle,RayonBalle,CoulBalle);
  {$ENDIF}
end;

procedure AfficheEcranFin (txt: String);
var
  SauvePal,Pal: Array [0..255] of RVB;
  ix,i: Byte;
begin
  { ============ FONDU vers le noir }
  { Sauve la palette }
  LitGrandePal (Pal, 0,256);
  move (Pal,SauvePal,SizeOf(Pal));

  { Couleurs origines -> Noir }
  LitGrandePal (Pal,0,256);
  for ix := 0 to 30 do begin
    for i:=0 to 255 do
      with Pal[i] do
      begin
        if R<3 then R:=0 else dec (R,3);
        if V<3 then V :=0 else dec ( V,3);
        if B<3 then B :=0 else dec ( B,3);
      end;

    AttendEcran;
    ChangeGrandePal (Pal,0,256);

    Pause (20);
  end;

  EffaceEcran (Noir);
  EcriVga (-1,-1,' '+txt+' ',Blanc,Vert);
  AfficheEcran;

  { ==== FONDU Noir -> Couleurs origines }
  for ix := 0 to 30 do begin
    for i:=0 to 255 do
      with Pal[i] do begin
        if SauvePal[i].R < R+3 then R := SauvePal[i].R else inc (R,3);
        if SauvePal[i].V < V+3 then V := SauvePal[i].V else inc (V,3);
        if SauvePal[i].B < B+3 then B := SauvePal[i].B else inc (B,3);
      end;

    AttendEcran;
    ChangeGrandePal (Pal,0,256);

    Pause (20);
  end;
end;

{ Renvoi TRUE : ok }
{ Renvoi FALSE : fin du jeu }
Function ChangeScore (Index: Byte; Plus: ShortInt) : Boolean;
begin
  if Index=1 then begin
    inc (Score1,Plus);

    { Joueur 1 trop nul ? }
    if Score1<=ScoreMin then begin
      AfficheEcranFin ('T''es trop nul !!!');
      ChangeScore := FALSE;
      Exit;
    end;

    { Joueur 1 trop fort ? }
    if ScoreMax<=Score1 then begin
      AfficheEcranFin ('T''as gagn !');
      ChangeScore := FALSE;
      Exit;
    end;

    {- Affiche score 1 ------}
    Str(score1,txt);   { change le "integer" en string }
    if length(txt)<>LongScoreMax then begin
      fillchar (txt[length(txt)+1],LongScoreMax-length(txt),ord(' '));
      txt[0] := chr(LongScoreMax);
    end;
    { affiche le nouveau }
    ecriVGA(TxtX_Score1,TxtScoreY,txt,CoulTxtScore,CoulTxtScoreFond);
  end else begin
    inc (Score2,Plus);

    { Joueur 2 trop nul ? }
    if Score2<=ScoreMin then begin
      AfficheEcranFin ('T''as niqu le PC, trop fort !');
      ChangeScore := FALSE;
      Exit;
    end;

    { Joueur 2 trop fort ? }
    if ScoreMax<=Score2 then begin
      AfficheEcranFin ('Le PC t''as encore nick la gueule');
      ChangeScore := FALSE;
      Exit;
    end;

    {- Affiche score 2 ------}
    Str(score2,txt);   { change le "integer" en string }
    if length(txt)<>LongScoreMax then begin
      fillchar (txt[length(txt)+1],LongScoreMax-length(txt),ord(' '));
      txt[0] := chr(LongScoreMax);
    end;

    { affiche le nouveau }
    ecriVGA(TxtX_Score2,TxtScoreY,txt,CoulTxtScore,CoulTxtScoreFond);
  end;
  ChangeScore := TRUE;
end;

Function ChangeVitesse (Plus: Real) : Boolean;
var TmpL: Real;
begin
  TmpL := Vitesse +Plus;
  if TmpL<VitesseMin then TmpL := VitesseMin;
  if VitesseMax<TmpL then TmpL := VitesseMax;
  if TmpL=Vitesse then exit;

  Vitesse := TmpL;
  Str (Vitesse:0:1, txt);
  txt := 'Vitesse = '+txt+' (change avec +/-)';
  EcriVga (TxtVitesseX,TxtVitesseY,txt,CoulTxtVitesse,CoulTxtVitesseFond);

  with Balle do begin
    if PlusX<0 then PlusX := -Vitesse else PlusX := Vitesse;
    if PlusY<0 then PlusY := -Vitesse else PlusY := Vitesse;
  end;
end;

Procedure DeplaceJoueur (Index: Byte; Plus: ShortInt);
var TmpY: Integer;
begin
  if Index=1 then with Joueur1 do begin
    TmpY := Y +Plus;
    if TmpY<CadreHaut then TmpY := CadreHaut;
    if CadreBas<TmpY+HautJoueur1 then TmpY := CadreBas-HautJoueur1;
    EffaceJoueur (Index);
    Y := TmpY;
    DessineJoueur (Index);
  end else with Joueur2 do begin
    TmpY := Y +Plus;
    if TmpY<CadreHaut then TmpY := CadreHaut;
    if CadreBas<TmpY+HautJoueur1 then TmpY := CadreBas-HautJoueur1;
    EffaceJoueur (Index);
    Y := TmpY;
    DessineJoueur (Index);
  end;
end;

procedure GereIA_niv1; begin
  {=== LA BALLE Vient vers le joueur 2 : va sur elle }

  { Balle en dessous du palette : le descend }
  if (Joueur2.Y+HautJoueur2<Balle.Y) then DeplaceJoueur (2, +Joueur2.Vitesse);

  { Balle au dessus du palette : le monte }
  if (Balle.Y+HautBalle<Joueur2.Y) then DeplaceJoueur (2, -Joueur2.Vitesse);
end;

procedure GereIA_niv2; begin
  if 0<Balle.PlusX then begin
    {=== LA BALLE Vient vers le joueur 2 : va sur elle }

    { Balle en dessous du palette : le descend }
    if (Joueur2.Y+HautJoueur2<Balle.Y) then DeplaceJoueur (2, +Joueur2.Vitesse);

    { Balle au dessus du palette : le monte }
    if (Balle.Y+HautBalle<Joueur2.Y) then DeplaceJoueur (2, -Joueur2.Vitesse);
  end else begin
    {=== LA BALLE Vient vers le joueur 1 : joueur 2 se centre }

    { Joueur 2 au dessus du centre : le descend }
    if (Joueur2.Y<CadreCentre) then DeplaceJoueur (2, +1);

    { Balle en dessous du palette : le monte }
    if (CadreCentre<Joueur2.Y) then DeplaceJoueur (2, -1);
  end;
end;

procedure GereIA_nivGod; begin
  if 0<Balle.PlusX then begin
    {=== LA BALLE Vient vers le joueur 2 : va sur elle }

    { Balle en dessous du palette : le descend }
    if (Joueur2.Y+HautJoueur2<Balle.Y) then DeplaceJoueur (2, +Joueur2.Vitesse);

    { Balle au dessus du palette : le monte }
    if (Balle.Y+HautBalle<Joueur2.Y) then DeplaceJoueur (2, -Joueur2.Vitesse);
  end else begin
    {=== LA BALLE Vient vers le joueur 1 : joueur 2 se centre }

    { Joueur 2 au dessus du centre : le descend }
    if (Joueur2.Y<CadreCentre) then begin
      if CadreCentre-Balle.Y<=Joueur2.Vitesse then
        DeplaceJoueur (2, +1)
      else
        DeplaceJoueur (2, +Joueur2.Vitesse);
    end;

    { Balle en dessous du palette : le monte }
    if (CadreCentre<Joueur2.Y) then begin
      if Balle.Y-CadreCentre<=Joueur2.Vitesse then
        DeplaceJoueur (2, -1)
      else
        DeplaceJoueur (2, -Joueur2.Vitesse);
    end;
  end;
end;

procedure GereIA; begin
  If score2<Score1 then NiveauIA:=3;
  If score1<Score2-5 then NiveauIA:=2;
  If score1<Score2-10 then NiveauIA:=1;
  Case NiveauIA of
    1: GereIA_niv1;
    2: GereIA_niv2;
  else GereIA_nivGod;
  end;
end;


{ PAUSE }
Procedure LancePause;
begin
  EmetSon(500,200);
  EmetSon(250,200);
  LitTouche;
  EmetSon(500,200);
  EmetSon(250,200);
end;


{ jeux }
Procedure LanceJeux; begin
  { Dessine l'cran }

  DessineLigneH(0,CadreHaut-1,LargEcran,CouleurBlanche);   { ligne du haut }
  DessineLigneH(0,CadreBas,LargEcran,CouleurBlanche); { ligne du bas }

  { Dessine le filet }
  iy := CadreHaut;
  while (iy<CadreBas) do begin
    Putpixel (LargEcran div 2,iy,CouleurBlanche);
    inc (iy,2);
  end;

  { Initialise les donnes }
  SCORE1 := 0; ChangeScore (1,0);
  SCORE2 := 0; ChangeScore (2,0);

  Vitesse := 2; ChangeVitesse (-1);

  if Random(2)=1 then InitBalle (-1) else InitBalle (+1);
  with Joueur1 do begin
    X := 1;
    Y := CadreCentre;
    Vitesse := 2;
  end;
  with Joueur2 do begin
    X := LargEcran-1-LargJoueur2;
    Y := CadreCentre;
    Vitesse := 2;
  end;
  { Sauve le fond de la balle pour la premire fois }
  InitBalle (+1);
  LitZone (Balle.X,Balle.Y,LargBalle,HautBalle,Balle.SauveFond);
  LitZone (joueur1.X,joueur1.Y,Largjoueur1,Hautjoueur1,joueur1.SauveFond);
  LitZone (joueur2.X,joueur2.Y,Largjoueur2,Hautjoueur2,joueur2.SauveFond);
  DessineJoueur (1);
  DessineJoueur (2);
  DessineBalle;
  EmetSon(500,200);
  EmetSon(250,200);

  LitTouche;
  repeat
  { Contrles au clavier }
  If touchPresse then begin
    key := LitTouche;

    case key of
    { Change la vitesse }
    '-' : ChangeVitesse (-0.1);
    '+' : ChangeVitesse (+0.1);

    { Dplace le joueur }
    _HAUT: DeplaceJoueur (1, -Joueur1.Vitesse);
    _BAS : DeplaceJoueur (1, +Joueur1.Vitesse);


    _ESPACE: lancePause;

    _ECHAPE : begin;   { si c'est echape... on se casse ! }
      AfficheEcranFin (' ---{ ExiT }--- ');
      Exit;
    end end;
  end; { du 'if TouchPresse' }

  {---- DESSINE LA BABALLE ---------------------------------------}


  { Efface la balle }
  EffaceBalle;

  {---- DEPLACE LA BABALLE ---------------------------------------}

  { Teste les colisions haut/bas de la balle }
  with Balle do begin
    { ======= LA BALLE PASSE A TRAVERS UNE RAQUETTE ? }

    { Passe derrire le Joueur 1 : celui-ci perd un point }
    IF X<Joueur1.X+LargJoueur1 then begin;
      EffaceBalle;
      InitBalle (1);
      if ChangeScore (1, -2)=FALSE then exit;
      LitZone (Balle.X,Balle.Y,LargBalle,HautBalle,Balle.SauveFond);
    end;

    { Passe derrire le Joueur2 : celui-ci perd un point }
    IF Joueur2.X<X+LargBalle then begin;
      EffaceBalle;
      InitBalle (-1);
      if ChangeScore (2, -2)=FALSE then exit;
      LitZone (Balle.X,Balle.Y,LargBalle,HautBalle,Balle.SauveFond);
    end;

    { ======= REBOND de la balle }

    { On touche le plafond : rebondi }
    IF Y+PlusY<CadreHaut then begin
      PlusY := -PlusY;
      EmetSon (250,1);
    end;

    { On touche le sol : rebondi }
    IF CadreBas<Y+HautBalle+PlusY then begin
      PlusY := -PlusY;
      EmetSon (250,1);
    end;

    { La balle rebondi contre le joueur 1 ? }
    IF (X+PlusX<Joueur1.X+LargJoueur1) and
      (Joueur1.Y<Y) and (Y+HautBalle<Joueur1.Y+HautJoueur1)
    then begin
      Balle.PlusX := -Balle.PlusX;           {| On vrifi si on est aussi }
      if ChangeScore (1, +1)=FALSE then exit;{| dans le Y}
      EmetSon (250,1);                       {| Si oui, balle touche raquette }
    end;                                     {| score + 1 }

    { La balle rebondi contre le joueur 2 ? }
    IF
      (Joueur2.X<X+LargBalle+PlusX) and
      (Joueur2.Y<Y+HautBalle) and (Y<Joueur2.Y+HautJoueur2)
    then begin
      PlusX := -PlusX;                                    {| On vrifi si on est aussi }
      if ChangeScore (2, +1)=FALSE then exit;             {| dans le Y}
      EmetSon (250,1);                                    {| Si oui, balle touche raquette }
    end;                                                  {| score + 1 }

    {====== Dplace la balle =======}
    Xr := Xr +PlusX; { a, a sert a faire }
    X := Round(Xr);
    Yr := Yr +PlusY; { partir la balle en diagonale }
    Y := Round(Yr);
  end;

  { =========== Intelligence artificielle : joueur 2 ========== }
  GereIA;

  { ====== Dessine joueur 2 ====== }

  { Dessine la balle }
  DessineBalle;




  {---- Attend que l'ecran est fini de dessiner -----------------}
  AttendEcran;

{-- FIN DES COLLISION -------------------------------------}
until key=_ECHAPE; {on touche echape ? on se bar ! }


End;
{/////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////}
{ FIN jeux }





{/////////////////////////////////////////////////////////////////}
{/////////////////////////////////////////////////////////////////}
{ ECRAN TITRE / MENU }

Procedure DessineMenu;
var p : integer;
begin
effaceEcran(CouleurNoire);
AffichePCX(0,0,'DATA\2.img');
ecriTSP(-1,5,'-* P  O  N  G *-',CouleurBlanche);
AfficheAide(1);
AfficheChoix;
ecriVGA(20,55,'->   Jeux',CouleurBlanche,7);
ecriVGA(20,80,'    About',CouleurBlanche,CouleurNoire);
ecrivga(0,193,'V '+version,15,0);

VidetamponClavier;
end;

{ Menu : }
{ -> TRUE=Lance le jeu }
{ -> FALSE=Exit }
Function Menu : Boolean;
 var Key : char;
     J,A : byte;

BEGIN;

Menu := TRUE;
DessineMenu;
J:=1; A:=0;

repeat;
  If TouchPresse then begin
    key:= LitTouche;
    case key of
    _HAUT : Begin
      J:=1; A:=0;
      EmetSon (1000,10);
      AfficheAide(1);
      ecriVGA(20,55,'->   Jeux',CouleurBlanche,7);
      ecriVGA(20,80,'    About',CouleurBlanche,CouleurNoire);
    End;

    _BAS : Begin
      J:=0; A:=1;
      EmetSon (1000,10);
      AfficheAide(0);
      ecriVGA(20,55,'     Jeux',CouleurBlanche,CouleurNoire);
      ecriVGA(20,80,'->  About',CouleurBlanche,7);
    End;

    _ENTREE : Begin
{///////////////////////////////////////////////////////// GO JEUX     }
      IF J=1 then begin
        Menu := TRUE;
        exit;
      end;
{///////////////////////////////////////////////////////// FIN GO JEUX }

{///////////////////////////////////////////////////////// ABOUT }
      IF A=1 then begin;
        effaceEcran(CouleurNoire);
        RempliZone(0,2,320,48,15);
        EcriVGA(-1,  2,'۱  ۱  ۱ ۱  ۱',CouleurBlanche,CouleurNoire);
        EcriVGA(-1, 10,'۱  ۱  ۱  ۱  ۱۱۱  ۱    ',CouleurBlanche,CouleurNoire);
        EcriVGA(-1, 18,'۱  ۱  ۱  ۱  ۱۱۱  ۱    ',CouleurBlanche,CouleurNoire);
        EcriVGA(-1, 26,'۱  ۱  ۱  ۱۱۱  ۱ ۱',CouleurBlanche,CouleurNoire);
        EcriVGA(-1, 34,'۱     ۱  ۱  ۱۱۱  ۱  ۱',CouleurBlanche,CouleurNoire);
        EcriVGA(-1, 42,'۱     ۱  ۱ ۱  ۱',CouleurBlanche,CouleurNoire);

        EcriVGA(5,70,'Salut !!!                              '+
                     'Le jeux est encor en developpement,    '+
                     'mais il est deja tres jouable. J''espere que '+
                     'sa vous plaira...                      '+
                     '                                       '+
                     'http://www.Dream-Rom.fr.st             '+
                     'atomx70@hotmail.com                    ',CouleurBlanche,CouleurNoire);

        EcriVGA(0,192,'PONG est un Freeware. ',252,CouleurNoire);
        J:=1; A:=0;
        LitTouche;
        DessineMenu;
      end;
    end;
  end; { de case }
  end; { de 'If TouchPresse' }
until key=_ECHAPE;

Menu := FALSE;
End;

{///////////////////////////////////////////////////////////////////}
{///////////////////////////////////////////////////////////////////}
{ FIN DE L'ECRAN TITRE / MENU }

{---------------------------------------------------------------------------}




{---------------------------------------------------------------------------}

procedure Intro;
var F: text;
    intro: string;
begin

  Assign(F,'DATA\INTRO.itr');  { on a deja vu l'intro en entier ? }
  Reset(F);                    { si oui, on la repasse pas ;-)    }
  ReadLn(F,Intro);             { voila }
  IF Intro='NON!!!' then Begin;
     Close(F);
     exit;                     { ...   }
  End;                         { ...   }
  Close(F);
  ModeVga256;
  AffichePCX(0,0,'DATA\5.img');
  EcriTSP (-1,3,'---===[[[ P O N G - par Rom01 ]]]===---',CouleurBlanche);
  EcriTSP (-1,30,'Information sur la partie -',CouleurNoire);
  EcriTSP (10,50,'MONTER',CouleurNoire); EcriTSP (90,50,' -> ',CouleurNoire); EcriTSP (115,50,'Flche haut',CouleurNoire);
  EcriTSP (10,60,'DESCENDRE',CouleurNoire); EcriTSP (90,60,' -> ',CouleurNoire); EcriTSP (115,60,'Flche bas',CouleurNoire);
  EcriTSP (10,70,'QUITTER',CouleurNoire); EcriTSP (90,70,' -> ',CouleurNoire); EcriTSP (115,70,'Echape',CouleurNoire);
  EcriTSP(-1,100,'les remerciment -',254);
  EcriTSP(10,120,'Haypo, Nico, Marvic, TwinnS''s, Quaderos, Crashi, Wal3x, Stingray et toutes les personnes que'+
  ' je connais.',254);
  EcriTSP (-1,180,'-> Pressez une touche pour continuer <-',250);
  LiTtouche;
end;

procedure EcriTSPCool (X,Y: integer; txt: String; coul: Byte);
var i: Byte;
begin
  for i := 1 to length(txt) do begin
    EcriTSP (X+(i*8),Y,txt[i],coul);
    if not TouchPresse then Pause (40);
  end;
  if not TouchPresse then Pause (150);
  if not TouchPresse then Pause (250);
end;

procedure Fin; begin
  EffaceEcran(CouleurNoire);
  EcriTSPCool (0,10,'PONG, freeware par rom01',255);
  EcriTSPCool (0,20,'Version : '+version,255);
  EcriTSPCool (0,30,'http://www.Dream-Rom.fr.st',255);
  if TouchPresse then LitTouche;
  LitTouche;

  ModeTXT;
  Halt;
end;

procedure Init; begin
  if MemAvail<64500 then begin
    EcriTc ('ERREUR : ',14+4*16); EcriTcr ('Mmoire libre insuffisante !',12);
    SauteLigne;
    Halt (8);
  end;

  changeVitesseClavier(0,0);

  NiveauIA := 1;
  ModeVga256;
end;

procedure InitGraph; begin
  ModeVga256;
  AffichePCX(0,0,'DATA\1.img');
end;

BEGIN;
  Init;

     {$IFNDEF Debug}
    Intro;
    while Menu do begin
      InitGraph;
      LanceJeux;
    end;
    {$ELSE}
    InitGraph;
    LanceJeux;
 {$ENDIF}
  Fin;
end.
